// ***************************************************************************
// *                                                                         *
// *           Aflow STEFANO CURTAROLO - Duke University 2003-2018           *
// *                                                                         *
// ***************************************************************************

#ifndef _AUROSTD_ARGV_H_
#define _AUROSTD_ARGV_H_

#include "aurostd.h"
//#include "aflow.h"

// ***************************************************************************
// GET WORLD
namespace aurostd {
  // ATTACH
  string attach(const string&) __xprototype;
  string attach(const string&,const string&) __xprototype;
  string attach(const string&,const string&,const string&) __xprototype;
  string attach(const string&,const string&,const string&,const string&) __xprototype;
  string attach(const string&,const string&,const string&,const string&,const string&) __xprototype;
  // get_arguments_from_input
  vector<string> get_arguments_from_input(int argc,char **argv) __xprototype;
  // get_flag without/with command list
  bool args2flag(vector<string>,const string&) __xprototype;
  bool args2flag(vector<string>,vector<string>&,const string&) __xprototype;
  // args2utype of utype type
  template<class utype> utype args2utype(vector<string>,const string&,utype) __xprototype;
  // get_xvector get_vector/deque
  template<class utype> xvector<utype> args2xvectorutype(vector<string>,const string&, xvector<utype>) __xprototype;
  template<class utype> xvector<utype> args2xvectorutype(vector<string>,const string&,const int&) __xprototype;
  template<class utype> vector<utype> args2vectorutype(vector<string>,const string&) __xprototype;
  template<class utype> deque<utype> args2dequeutype(deque<string>,const string&) __xprototype;
 // args2vectorstring
  string args2string(vector<string>,const string&,const string&) __xprototype;
  string args2string(vector<string>,vector<string>&,const string&,const string&) __xprototype;
  // args2vectorstring
  vector<string> args2vectorstring(vector<string>,const string&,const string&) __xprototype;

  //__get_itemized_vector_string
  bool get_itemized_vector_string_from_input(vector<string> &argv,const string& s0,vector<string>& tokens,const string& delimiter) __xprototype;
  bool get_itemized_vector_string_from_input(vector<string> &argv,const string& s0,const string& s1,vector<string>& tokens,const string& delimiter) __xprototype;
  bool get_itemized_vector_string_from_input(vector<string> &argv,const string& s0,const string& s1,const string& s2,vector<string>& tokens,const string& delimiter) __xprototype;
  bool get_itemized_vector_string_from_input(vector<string> &argv,const string& s0,const string& s1,const string& s2,const string& s3,vector<string>& tokens,const string& delimiter) __xprototype;
  // getproto_itemized_vector_string_from_input
  bool getproto_itemized_vector_string_from_input(vector<string> &argv,const string& s0,vector<string>& tokens,const string& delimiter=":") __xprototype;
  bool getproto_itemized_vector_string_from_input(vector<string> &argv,const string& s0,const string& s1,vector<string>& tokens,const string& delimiter=":") __xprototype;
  bool getproto_itemized_vector_string_from_input(vector<string> &argv,const string& s0,const string& s1,const string& s2,vector<string>& tokens,const string& delimiter=":") __xprototype;
  bool getproto_itemized_vector_string_from_input(vector<string> &argv,const string& s0,const string& s1,const string& s2,const string& s3,vector<string>& tokens,const string& delimiter=":") __xprototype;

  // args2attachedflag without/with commands
  bool args2attachedflag(vector<string>,const string&) __xprototype;
  // args2attachedflag with commands
  bool args2attachedflag(vector<string>,vector<string>&,const string&) __xprototype;
  // args2attachedstring
  // [OBSOLETE] string args2attachedstring(vector<string>,const string&) __xprototype;
  // [OBSOLETE] string args2attachedstring(vector<string>,const string&,const string&) __xprototype;
  string args2attachedstring(vector<string>,const string&,string="") __xprototype;
  // [OBSOLETE] string args2attachedstring(vector<string>,const string&,const string&,const string&) __xprototype;
  // [OBSOLETE] string args2attachedstring(vector<string>,const string&,const string&,const string&,const string&) __xprototype;
  // [OBSOLETE] string args2attachedstring(vector<string>,const string&,const string&,const string&,const string&,const string&) __xprototype;
  // args2attachedint
  // [OBSOLETE] int args2attachedint(vector<string> argv,const string&,const int&) __xprototype;
  // [OBSOLETE] int args2attachedint(vector<string> argv,const string&,const string&,const int&) __xprototype;
  // args2attacheddouble
  // [OBSOLETE] double args2attacheddouble(vector<string> argv,const string&,const double&) __xprototype;
  // [OBSOLETE] double args2attacheddouble(vector<string> argv,const string&,const string&,const double&) __xprototype;
  // args2attachedutype
  template<typename utype> utype args2attachedutype(vector<string> argv,const string&,const utype&) __xprototype;
  // [OBSOLETE] template<typename utype> utype args2attachedutype(vector<string> argv,const string&,const string&,const utype&) __xprototype;
  // [OBSOLETE] template<typename utype> utype args2attachedutype(vector<string> argv,const string&,const string&,const string&,const utype&) __xprototype;
  // [OBSOLETE] template<typename utype> utype args2attachedutype(vector<string> argv,const string&,const string&,const string&,const string&,const utype&) __xprototype;
  string args2attachedutype(vector<string> argv,const string&,const string&) __xprototype;
  // [OBSOLETE] string args2attachedutype(vector<string> argv,const string&,const string&,const string&) __xprototype;
  // [OBSOLETE] string args2attachedutype(vector<string> argv,const string&,const string&,const string&,const string&) __xprototype;
  // [OBSOLETE] string args2attachedutype(vector<string> argv,const string&,const string&,const string&,const string&,const string&) __xprototype;
}

#endif

// ***************************************************************************
// *                                                                         *
// *           Aflow STEFANO CURTAROLO - Duke University 2003-2018           *
// *                                                                         *
// ***************************************************************************
